#define INSTANTIATING_TEMPLATES

#include <debtags/Tag.h>

#include <apt-front/cache/entity/package.h>
#include <tagcoll/CardinalityStore.cc>
#include <tagcoll/SmartHierarchy.cc>
#include <debtags/Filters.h>

template class CardinalityStore<aptFront::cache::entity::Package, Debtags::Facet>;
template class SmartHierarchyNode<aptFront::cache::entity::Package, Debtags::Facet>;

template class Debtags::TagToFacet<aptFront::cache::entity::Package>;


#if 0
#include "DebtagsDocument.h"

#include <debtags/DebtagsTODO.cc>
#include <tagcoll/InputMerger.cc>
#include <tagcoll/ItemGrouper.cc>
#include <tagcoll/ExpressionFilter.cc>

template class InputMerger<DebtagsDocument::package, Debtags::Tag>;
template class ItemGrouper<DebtagsDocument::package, Debtags::Tag>;
template class DebtagsTODOSpecials<DebtagsDocument::package>;


template<>
void ExpressionFilter<DebtagsDocument::package, Debtags::Tag>::consume(const DebtagsDocument::package& item, const Tagcoll::OpSet<Debtags::Tag>& tags)
{
	Tagcoll::OpSet<std::string> stringTags;
	for (Tagcoll::OpSet<Debtags::Tag>::const_iterator i = tags.begin(); i != tags.end(); i++)
		stringTags += i->fullname();
	if (match(stringTags))
	{
		matched++;
		this->consumer->consume(item, tags);
	}
}

template<>
void ExpressionFilter<DebtagsDocument::package, Debtags::Tag>::consume(const Tagcoll::OpSet<DebtagsDocument::package>& items, const Tagcoll::OpSet<Debtags::Tag>& tags)
{
	Tagcoll::OpSet<std::string> stringTags;
	for (Tagcoll::OpSet<Debtags::Tag>::const_iterator i = tags.begin(); i != tags.end(); i++)
		stringTags += i->fullname();
	if (match(stringTags))
	{
		matched += items.size();
		this->consumer->consume(items, tags);
	}
}

template class Tagcoll::ExpressionFilter<DebtagsDocument::package, Debtags::Tag>;


#include <debtags/DebtagsFilters.cc>
template class UntaggedFilter<DebtagsDocument::package>;
#endif

#if 0

#include <debtags/Package.h>
#include <debtags/Tag.h>

#include <tagcoll/InputMerger.cc>
#include <tagcoll/ItemGrouper.cc>
#include <tagcoll/OpSet.cc>
#include <tagcoll/TagcollConsumer.cc>
#include <tagcoll/ExpressionFilter.cc>

// Provide needed template specialisations

template<>
void ExpressionFilter<Debtags::Package, Debtags::Tag>::consume(const Debtags::Package& item, const Tagcoll::OpSet<Debtags::Tag>& tags)
{
	Tagcoll::OpSet<std::string> stringTags;
	for (Tagcoll::OpSet<Debtags::Tag>::const_iterator i = tags.begin(); i != tags.end(); i++)
		stringTags += i->fullname();
	if (match(stringTags))
	{
		matched++;
		this->consumer->consume(item, tags);
	}
}

template<>
void ExpressionFilter<Debtags::Package, Debtags::Tag>::consume(const Tagcoll::OpSet<Debtags::Package>& items, const Tagcoll::OpSet<Debtags::Tag>& tags)
{
	Tagcoll::OpSet<std::string> stringTags;
	for (Tagcoll::OpSet<Debtags::Tag>::const_iterator i = tags.begin(); i != tags.end(); i++)
		stringTags += i->fullname();
	if (match(stringTags))
	{
		matched += items.size();
		this->consumer->consume(items, tags);
	}
}


// Instantiate needed templates

template class InputMerger<std::string, Debtags::Tag>;
template class ItemGrouper<std::string, Debtags::Tag>;
template class ExpressionFilter<Debtags::Package, Debtags::Tag>;
#endif

// vim:set ts=4 sw=4:
